Plague Inc. is a famous game, which player develop virus to ruin the world.

JSZKC wants to model this game. Let's consider the world has N\times MN×M cities. The world has NN rows and MMcolumns. The city in the XX row and the YY column has coordinate (X,Y)(X,Y).

There are KK cities which are sources of infection at the 0^{th}0th day. Each day the infection in any infected city will spread to the near four cities (if exist).

JSZKC wants to know which city is the last one to be infected. If there are more than one cities , answer the one with smallest XX firstly, smallest YY secondly.

Input Format

The input file contains several test cases, each of them as described below.

  • The first line of the input contains two integers NN and MM (1 \le N,M \le 2000)(1≤N,M≤2000), giving the number of rows and columns of the world.
  • The second line of the input contain the integer KK (1 \le K \le 10)(1≤K≤10).
  • Then KK lines follow. Each line contains two integers X_iXi​ and Y_iYi​, indicating (X_i,Y_i)(Xi​,Yi​) is a source. It's guaranteed that the coordinates are all different.

There are no more than 2020 test cases.

Output Format

For each testcase, output one line with coordinate XX and YY separated by a space.

样例输入

3 3
1
2 2
3 3
2
1 1
3 3

样例输出

1 1
1 3

其实这道题我是很气的,  我加了队列超时,  剪枝也超时。   后面看到通过率挺高的,就怀疑是暴力水题,结果果然是这样。但是我还是写在博客上,帮助理解自己BFS;

超时代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<cmath>
#include<algorithm>
#include<vector>
#include<queue>
#include<stack>
#define Max(a,b) ((a)>(b)?(a):(b))
#define Min(a,b) ((a)<(b)?(a):(b))
#define Swap(a,b,t) t=a,a=b,b=t
#define Mem0(x) memset(x,0,sizeof(x))
#define Mem1(x) memset(x,-1,sizeof(x))
#define MemX(x) memset(x,0x3f,sizeof(x));
using namespace std;
typedef long long ll;
const int inf=0x3f3f3f;
const double eps=1e-12;
int n,m,k;
const int MAXN=2005;
int maxx,sum;
struct s{
    int x,y,second;
}map[MAXN][MAXN];
bool vis[MAXN][MAXN];
queue<s> q;
int dir[4][2]={-1,0,0,1,1,0,0,-1};
bool Solve(s f)
{
    if (f.x<=0||f.y<=0||f.x>n||f.y>m||vis[f.x][f.y])
        return false;
    return true;
}    
void BFS()
{
    while (!q.empty())
    {
        if (sum==0)
            break;
        s f,node;
        node=q.front();
        q.pop();
        for (int t=0;t<4;t++){
            f.x=node.x+dir[t][0];
            f.y=node.y+dir[t][1];
            f.second=node.second;
            if (Solve(f)){
                f.second=node.second+1;
                map[f.x][f.y].second=f.second;
                sum--;
                vis[f.x][f.y]=true;        
                q.push(f);
                maxx=f.second;
            }
        }
    }
}
int main()
{
    while (scanf("%d%d",&n,&m)!=EOF){
        sum=n*m;
        while (!q.empty())
            q.pop();
        memset(vis,0,sizeof(vis));
        for (int i=1;i<=n;i++){
            for (int j=1;j<=m;j++){
                map[i][j].second=0;
            }
        }
        scanf("%d",&k);

sum-=k;
        int x,y,flag=1;
        for (int i=1;i<=k;i++){
            scanf("%d%d",&x,&y);
            map[x][y].x=x;
            map[x][y].y=y;
            map[x][y].second=1;
            vis[x][y]=true;
            q.push(map[x][y]); 
        }
        if (n*m<=k){
            printf("1 1\n");
            continue;
        }        
        BFS();
    /*    for (int i=1;i<=n;i++){
            for (int j=1;j<=m;j++)
                printf("%d ",map[i][j].second);
            cout<<endl;
        }    */    
        for (int i=1;i<=n&&flag;i++){
            for (int j=1;j<=m;j++){
                if (map[i][j].second==maxx){
                    flag=0;
                    printf("%d %d\n",i,j);
                    break;
                }
            }
        }
    }
    return 0;
}

暴力AC代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<cmath>
#include<algorithm>
#include<vector>
#include<queue>
#include<stack>
#define Max(a,b) ((a)>(b)?(a):(b))
#define Min(a,b) ((a)<(b)?(a):(b))
#define Swap(a,b,t) t=a,a=b,b=t
#define Mem0(x) memset(x,0,sizeof(x))
#define Mem1(x) memset(x,-1,sizeof(x))
#define MemX(x) memset(x,0x3f,sizeof(x));
using namespace std;
typedef long long ll;
const int inf=0x3f3f3f;
const double eps=1e-12;
int MAX;
int map[2010][2010];
int main()
{
    int n,m,k,x,y,cnt;
    while (scanf("%d%d",&n,&m)!=EOF){
        MAX=-inf;
        scanf("%d",&k);
        int g=k;
        MemX(map);
        while (k--){
//            system("pause");
            cin>>x>>y;
            for (int i=1;i<=n;i++){
                for (int j=1;j<=m;j++){
                    if (i==x||j==y)
                        map[i][j]=Min(map[i][j],abs(x-i)+abs(y-j));
                    else 
                        map[i][j]=Min(map[i][j],abs(x-i)+abs(y-j)-1);    
                }
            }        
        }
        for (int i=1;i<=n;i++){
            for (int j=1;j<=m;j++){
                if (map[i][j]>MAX)
                    MAX=map[i][j];
            }
        }
/*    */    for (int i=1,flag=1;flag&&i<=n;i++){
            for (int j=1;j<=m;j++){
                if (MAX==map[i][j]){
                    flag=0;
                    printf("%d %d\n",i,j);
                    break;
                }
            }
        }
    }
    return 0;
}

BFS 队列的更多相关文章

  1. POJ 3278 Catch That Cow[BFS+队列+剪枝]

    第一篇博客,格式惨不忍睹.首先感谢一下鼓励我写博客的大佬@Titordong其次就是感谢一群大佬激励我不断前行@Chunibyo@Tiancfq因为室友tanty强烈要求出现,附上他的名字. Catc ...

  2. 农夫过河 (BFS)(队列)

    1 .问题描述 要求设计实现农夫过河问题(农夫带着一只狼,一只养,一棵白菜,一次只能带一个东西)如何安全过河. 2 .问题的解决方案: 可以用栈与队列.深度优先搜索算法及广度优先搜索算法相应的原理去解 ...

  3. 拆边+BFS队列骚操作——cf1209F

    这个拆边+队列操作实在是太秒了 队列头结点存的是一个存点集的vector,1到这个点集经过的路径权值是一样的,所以向下一层拓展时,先依次走一遍每个点的0边,再走1边...以此类推,能保证最后走出来的路 ...

  4. POJ——3278 Catch That Cow(BFS队列)

    相比于POJ2251的三维BFS,这道题做法思路完全相同且过程更加简单,也不需要用结构体,check只要判断vis和左右边界的越界情况就OK. 记得清空队列,其他没什么好说的. #include< ...

  5. hdoj 2612 Find a way【bfs+队列】

    Find a way Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total ...

  6. poj 3278 Catch That Cow(bfs+队列)

    Description Farmer John has been informed of the location of a fugitive cow and wants to catch her i ...

  7. HDU 6171 Admiral(双向BFS+队列)题解

    思路: 最大步骤有20,直接BFS会超时. 因为知道开始情况和结果所以可以用双向BFS,每个BFS规定最大步骤为10,这样相加肯定小于20.这里要保存每个状态搜索到的最小步骤,用Hash储存.当发现现 ...

  8. 剑指offer:对称的二叉树(镜像,递归,非递归DFS栈+BFS队列)

    1. 题目描述 /** 请实现一个函数,用来判断一颗二叉树是不是对称的. 注意,如果一个二叉树同此二叉树的镜像是同样的,定义其为对称的 */ 2. 递归 思路: /** 1.只要pRoot.left和 ...

  9. bfs(队列模板)

    [题目描述] 当你站在一个迷宫里的时候,往往会被错综复杂的道路弄得失去方向感,如果你能得到迷宫地图,事情就会变得非常简单. 假设你已经得到了一个n*m的迷宫的图纸,请你找出从起点到出口的最短路. [输 ...

随机推荐

  1. luogu P1710 地铁涨价

    嘟嘟嘟 一道最短路好题. 首先明确一点,把一条边的边权变成2,等于删去这条边.因为变成2后最短路肯定不会经过这条边,就相当于删去这条边了. 所以题目变成了依次删去Q条边,求每一次删完边后有几个点的最短 ...

  2. java 线程状态图

  3. 用jquery写的json省市县三级联动下拉

    <form action="#" name="myform"> <label>省</label><select nam ...

  4. C# DataSet.Designer.cs

    今天在做项目的时候,发现一个很奇葩的问题,VS 中DataSet数据集的问题Dataset数据集更新,在保存后原有的Dataset.Designer.cs不变,又增加一个新的Dataset1.Desi ...

  5. 【luogu P3369 【模板】普通平衡树(Treap/SBT)】 模板 Scapegoat Tree

    #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> ...

  6. sql中 decode() 的用法

    sql中 decode() 的用法 SELECT ID,DECODE(inParam,'Param','value1' ,'value2') name FROM yytj2018 如果 inParam ...

  7. ASP.NET mvc 验证码 (转)

    ASP.net 验证码(C#) MVC http://blog.163.com/xu_shuhao/blog/static/5257748720101022697309/ 网站添加验证码,主要为防止机 ...

  8. rest_framework -- 认证组件

    #####认证组件##### 一.认证是什么就不说了,某些网页必须是用户登陆之后,才能访问的,所以这时候就需要用上认证组件. 你不用rest_framework的认证组件也行,这种认证的话,完全可以自 ...

  9. (eclipse)统一文件编码和代码风格

    前言 1>每个人的代码风格不一样,以至于代码各式各样,有习惯=号左右加空格的,有习惯不加的,此举有时还会影响svn提交代码 2>注释代码不一样,并且注释风格也不一样 统一文件编码和代码风格 ...

  10. POJ 1066--Treasure Hunt(判断线段相交)

    Treasure Hunt Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 7857   Accepted: 3247 Des ...